C        MAIN PROGRAM THINWIRE
C         ORIGINAL PROGRAM BY J. H. RICHMOND, 1974
C          MODIFIED MAY 1993, R. P. HAVILAND
      COMPLEX EP2,EP3,ETA,GAM,Y11,Z11,ZS
      COMPLEX EPPS,EPTS,ETPS,ETTS,EX,EY,EZ
      COMPLEX C(1830),CJ(60),EP(60),ET(60),EPP(60),ETT(60)
      DIMENSION I1(60),I2(60),I3(60),JA(60),JB(60)
      COMPLEX CGD(50),SGD(50),CG(100),VG(100),ZLD(100)
      DIMENSION D(50),IA(50),IB(50),ISC(50),MD(50,4),ND(50)
      DIMENSION X(55),Y(55),Z(55)
      CHARACTER * 31 INFILE
      CHARACTER * 31 OUTPATH,PATPATH 
      CHARACTER * 31 NAS
      CHARACTER * 31 DAS
      CHARACTER * 31 FPS
      CHARACTER * 1 ICR,ILF,IESC,ISI
      CHARACTER * 4 SPC
      DATA PI,TP/3.14159,6.28318/
      DATA E0,U0/8.854E-12,1.2566E-6/
   2  FORMAT ( 1X,8F15.7)
   3  FORMAT ( 4F15.7)
   4  FORMAT ( 1X,1I5,8F14.6)
   5  FORMAT ( 1H0)
   6  FORMAT ( 1X,6F15.7)
   7  FORMAT ( 8F10.5)
   8  FORMAT ( 1X,1I4,13I5)
   9  FORMAT ( 3X,'MAX = ',I5,3X,'MIN = ',I5,3X,'N = ',I5)
  10  FORMAT ( 4Z2.0)
      SPC='    '
      ICR=13
      ILF=10
      IESC=27
      ISI=15
      ICJ=60
      INM=50
      DO 15 J=1,INM
  15  ISC(J)=0
C      UNIT USE- FILEIN=5, SCREEN=2, (PRINTER=6 OR FILEOUT=6)
C                PATTERN=7
C      SETUP FOR SCREEN OUTPUT
C      OPEN (UNIT=2, FILE='CON:')
C      GET FILEIN DATA
 6020 TYPE *, ' ENTER FILEPATH+FILENAME FOR INPUT  '
      ACCEPT INFILE
C      SETUP FOR FILE INPUT
      OPEN (UNIT=5, FILE=INFILE,ERR=6020)
C      NOW GET SOME DATA
 6024 READ (5,*)NAS,DAS,FPS 
C      SET FILEOUT DATA
 6021 TYPE *, ' ENTER 1=OUTPUT TO PRINTER, 2=OUTPUT TO FILE  '
      ACCEPT IFILEOUT
      IF (IFILEOUT .EQ. 1) GOTO 6022
      IF (IFILEOUT .NE. 2) GOTO 6021
 6050 TYPE *, ' ENTER FILEPATH+FILENAME+.OUT    '
      ACCEPT  OUTPATH
C       SETUP FOR FILE OUTPUT
      OPEN (UNIT=6,FILE=OUTPATH,ERR=6050,STATUS='NEW')
      GOTO 6023
C      SETUP FOR PRINTER OUTPUT
 6022 OPEN (UNIT=6,FILE='PRT:')
 6023 TYPE *, '    SAVE PATTERN FILE, 1=YES, OTHER=NO ?   '
      ACCEPT IPATFILE
      IF IPATFILE .NE. 1 GOTO 6025
      TYPE *, ' ENTER FILEPATH+FILENAME+.PAT    '
      ACCEPT PATPATH
      OPEN (UNIT=7,FILE=PATPATH, ERR=6023, STATUS='NEW') 
 6025 WRITE (6,*) ISI  !COMPRESSED PRINT 
C      NOW GET DATA 
C      WRITE (6,*) IESC,'Q',130  ! RIGHT MARGIN                 
 6026 WRITE (6,*) ' THIN-WIRE ANALYSIS PROGRAM '   !READ 0
      WRITE (6,*) '  ANTENNA      ',NAS
      WRITE (6,*) '   OF FILE     ',FPS
      WRITE (6,*) '    DATED      ',DAS
      WRITE (6,*) '    REFERENCE  ',INFILE
      WRITE (6,*) ' '
      READ (5,*)BM,ER2,SIG2,TD2                    !READ1
      WRITE (6,*)'INSULATION DIA.       K               LOSS'
      WRITE (6,2)BM,ER2,SIG2,TD2
      READ (5,*)AM,CMM,ER3,SIG3,TD3                !READ2
      WRITE (6,*)'WIRE     DIA          RHO               MEDIUM'
      WRITE (6,2)AM,CMM,ER3,SIG3,TD3
      READ (5,*)IBISC,IGAIN,INEAR,ISCAT,IWR,NGEN,NM,NP,NLOAD  !READ 3
      WRITE (6,*)'  FLAGS                     GENS SEGS POINTS LOADS'
      WRITE (6,8)IBISC,IGAIN,INEAR,ISCAT,IWR,NGEN,NM,NP,NLOAD
      READ (5,*)FMC,PHA,PHAI,PHAN,THA,THAI,THAN         !READ 4
      WRITE (6,*)'FREQUENCY, MHZ'
      WRITE (6,2)FMC
      WRITE (6,*)'ELEV  INIT., INC., STEPS    AZM  INIT., INC., STEPS'
      WRITE (6,*)'FAR FIELD ANGLES'
      WRITE (6,2)PHA,PHAI,PHAN,THA,THAI,THAN
      READ (5,*)PHI,PHII,PHIN,THI,THII,THIN             !READ 5
      WRITE (6,*)'BACK SCATTER ANGLES'
      WRITE (6,2)PHI,PHII,PHIN,THI,THII,THIN
      READ (5,*)PHS,PHSI,PHSN,THS,THSI,THSN             !READ 6   
      WRITE (6,*)'BISTATIC SCATTER ANGLES'
      WRITE (6,2)PHS,PHSI,PHSN,THS,THSI,THSN
      WRITE (6,*)'SEGMENT, END1, END2'
      DO 22 J=1,NM
      READ (5,*)IA(J),IB(J)                             !READ 7
  22  WRITE (6,8)J,IA(J),IB(J)
      WRITE (6,*)'POINT #       LOCATIONS, XYZ  METERS'
      DO 40 I=1,NP
      READ (5,*)X(I),Y(I),Z(I)                          !READ 8
  40  WRITE (6,4)I,X(I),Y(I),Z(I) 
  41  WRITE (6,*)' NEAR FIELD  X Y Z'
      READ (5,*) XP,YP,ZP
  42  WRITE (6,*) XP,YP,ZP
  43  FHZ=FMC*1.E6
      OMEGA=TP*FHZ
      DO 44 I=1,NP
      IF (BM .GT. AM) ISC(I)=1
  44  CONTINUE 
      IF (SIG2.LT.0.) EP2=ER2*E0*CMPLX(1.,-TD2)
      IF (TD2.LT.0.) EP2=CMPLX(ER2*E0,-SIG2/OMEGA)
      IF (SIG3.LT.0.) EP3=ER3*E0*CMPLX(1.,-TD3)
      IF (TD3.LT.0.) EP3=CMPLX(ER3*E0,-SIG3/OMEGA)
      ETA=CSQRT(U0/EP3)
      GAM=OMEGA*CSQRT(-U0*EP3)
  59  CALL SORT(IA,IB,I1,I2,I3,JA,JB,MD,ND,NM,NP,N,MAX,MIN,ICJ,INM)
      WRITE (6,*)' '
      WRITE (6,9)MAX,MIN,N
      WRITE (6,*)' '
      IF MIN.LT.1 WRITE (6,*)'***    UNCONNECTED WIRE   ***'
      IF (MAX.GT.4 .OR. MIN.LT.1 .OR. N.GT.ICJ) GO TO 800
      INT=4
      I12=1
      DO 60 J=1,NM
      VG(J)=(.0,.0)
      ZLD(J)=(.0,.0)
      JJ=J+NM
      VG(JJ)=(.0,.0)
  60  ZLD(JJ)=(.0,.0)
C      IF (NGEN.GT.0) VG(NGEN)=(1.,0.) !TO REPLACE UP TO 64, NO LOAD,1 GEN
      IF (NLOAD .LE. 0) GO TO 62
      WRITE (6,*)'LOAD               LR LI          POINT#'
      DO 61 I=1,NLOAD
      READ (5,*)LOADR,LOADI,JLOAD                       !READ 9
      ZLD(JLOAD)=CMPLX(LOADR,LOADI)
  61  WRITE (6,*)ZLD(JLOAD),'   ',JLOAD
      TYPE *, 'SET INTEGRATION, 0=NO CHANGE, -1=EXACT'
      TYPE *, ' <4=FAST, LOW, >4=SLOW, HIGH ACCURACY'
      ACCEPT INTSET
      IF (INTSET .LE. -1) INT=0
      IF (INTSET .GT. 0) INT=INTSET
      WRITE (6,*) 'INT VARIABLE =',INT
  62  IF (NGEN .LE. 0) GO TO 64
      WRITE (6,*)'GENERATOR          VR VI          POINT#'
      DO 63 I=1,NGEN
      READ (5,*)GENR,GENI,JGEN                     !READ 10
      VG(JGEN)=CMPLX(GENR,GENI)     
  63  WRITE (6,*)VG(JGEN),'   ',JGEN
  64  CALL SGANT(IA,IB,INM,INT,ISC,I1,I2,I3,JA,JB,MD,N,ND,NM,NP
     2,AM,BM,C,CGD,CMM,D,EP2,EP3,ETA,FHZ,GAM,SGD,X,Y,Z,ZLD,ZS)
      IF (N.LE.0) GO TO 800
      IF (NGEN.LE.0) GO TO 400 
      CALL GANT1(IA,IB,INM,IWR,I1,I2,I3,I12,JA,JB,MD,N,ND,NM,AM
     2,C,CJ,CG,CMM,D,EFF,GAM,GG,CGD,SGD,VG,Y11,Z11,ZLD,ZS)
      WRITE (6,*)'EFFICIENCY             INPOWER         RIN   XIN'
      WRITE (6,3)EFF,GG,Z11
  200 IF (INEAR.LE.0) GO TO 300
      CALL  GNFLD(IA,IB,INM,I1,I2,I3,MD,N,ND,NM,AM,CGD,SGD,ETA,GAM
     2,CJ,D,X,Y,Z,XP,YP,ZP,EX,EY,EZ)
      WRITE (6,*)'COMPLEX NEAR ELECTRIC FIELD VALUES'
      WRITE (6,*)'      X               Y                  Z'
      WRITE (6,*) EX,SPC,EY,SPC,EZ
  300 IF (IGAIN.LE.0) GO TO 400
      INC=0
      WRITE (6,*)'FAR FIELD'
      WRITE (6,*)'      ANGLES              VALUES'
      WRITE (6,*)'AZMUITH    ZENITH   H-FIELD    V-FIELD   TOTAL,DB'     
      DO 310 I=PHA,PHAI*PHAN,PHAI
      DO 310 J=THA,THAI*THAN,THAI
      PH=I
      TH=J
      CALL   GFFLD(IA,IB,INC,INM,IWR,I1,I2,I3,I12,MD,N,ND,NM,AM
     2,ACSP,ACST,C,CGD,CG,CJ,CMM,D,ECSP,ECST,EP,ET,EPP,ETT,EPPS,EPTS
     3,ETPS,ETTS,GG,GPP,GTT,PH,SGD,SCSP,SCST,SPPM,SPTM,STPM,STTM,TH
     4,X,Y,Z,ZLD,ZS,ETA,GAM)
      TOT=GPP*GPP+GTT*GTT
      IF (TOT .LE. 0) DTOT=-999
      IF (TOT .GT. 0) DTOT=5*LOG10(TOT)
      WRITE (6,*)PH,SPC,TH,SPC,GPP,SPC,GTT,SPC,DTOT
      IF IPATFILE .NE. 1  GOTO 310
      WRITE (7,*)PH,TH,GPP,GTT,DTOT
  310 CONTINUE
  400 IF (ISCAT.LE.0) GO TO 600
      INC=1
      WRITE (6,*)   'BACKSCATTER        ECHO AREAS,  CROSS SECTIONS '
      WRITE (6,*)'AZMUITH   ELEVATION   APP     APT     ATP     ATT'
      WRITE (6,*)'           ABSORB P,T   EXTINCT P,T   SCATTER P,T'
      DO 410 I=PHI,PHII*PHIN,PHII
      DO 410  J=THI,THII*THIN,THII
      PH=I
      TH=J
      CALL   GFFLD(IA,IB,INC,INM,IWR,I1,I2,I3,I12,MD,N,ND,NM,AM
     2,ACSP,ACST,C,CGD,CG,CJ,CMM,D,ECSP,ECST,EP,ET,EPP,ETT,EPPS,EPTS
     3,ETPS,ETTS,GG,GPP,GTT,PH,SGD,SCSP,SCST,SPPM,SPTM,STPM,STTM,TH
     4,X,Y,Z,ZLD,ZS,ETA,GAM)
      WRITE (6,6)PH,TH,SPPM,SPTM,STPM,STTM
      WRITE (6,6)ACSP,ACST,ECSP,ECST,SCSP,SCST
  410 CONTINUE
  500 IF (IBISC.LE.0) GO TO 600
      INC=2
      WRITE (6,*)'BI-STAT SCATTER  VALUES'
      WRITE (6,*)' WITH INCIDENT WAVE PHI, THETA OF'
      WRITE (6,*) PHI, THI
      WRITE (6,*)'AZMUITH       ELEVATION      H-FIELD      V-FIELD' 
      DO 510 I=PHS,PHSI*PHSN,PHSI
      DO 510 J=THS,THSI*THSN,THSI
      PH=I
      TH=J    
      CALL   GFFLD(IA,IB,INC,INM,IWR,I1,I2,I3,I12,MD,N,ND,NM,AM
     2,ACSP,ACST,C,CGD,CG,CJ,CMM,D,ECSP,ECST,EP,ET,EPP,ETT,EPPS,EPTS
     3,ETPS,ETTS,GG,GPP,GTT,PH,SGD,SCSP,SCST,SPPM,SPTM,STPM,STTM,TH
     4,X,Y,Z,ZLD,ZS,ETA,GAM)
      WRITE (6,6)PH,TH,SPPM,SPTM,STPM,STTM
  510 CONTINUE
  600 CONTINUE

  800 CLOSE (2)
      CLOSE (5)
      CLOSE (6)
      CLOSE (7)
      WRITE (6,*) ' RUN COMPLETED'
      WRITE (6,*)IESC,'@'    !RESET PRINTER
      STOP
